#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <assert.h>
#define rep(E, F) for (E = 0; E < (F); E++)
#define SWAP(E, F) { int swap = (E); (E) = (F); (F) = swap; }
int min(int a, int b) { if (a > b) return b; return a; }
int max(int a, int b) { if (a < b) return b; return a; }
double get_double();
int get_int()
{
	int r = 0, c = getchar(), s = (c == ' ' ? -1 : 1);
	if (c < '0' || c > '9') return get_int();
	for (; c >= '0' && c <= '9'; c = getchar()) r = r*10 + c - '0';
	return s*r;
}

int perm(int* a, int* b, int n, int x)
{
	int i;
	if (x == n)
	{
		rep(i, n) if (a[i] != b[i]) break;
		return i == n;
	}
	for (i = x; i < n; i++)
	{
		SWAP(a[x], a[i]);
		if (perm(a, b, n, x + 1)) return 1;
		SWAP(a[x], a[i]);
	}
	return 0;
}

int foo(int* a, int* b, int n, int x)
{
	SWAP(a[x], a[n - 1]);
	int r = perm(a, b, n - 1, 0);
	SWAP(a[x], a[n - 1]);
	return r;
}

int main()
{
	int i, j, n = get_int();
	int a[n], b[n - 1];
	rep(i, n) a[i] = get_int();
	rep(i, n - 1) b[i] = get_int();
	rep(i, n) if (foo(a, b, n, i)) break;
	printf("%d\n", a[i]);
	return 0;
}

