import sys

try:
    input = raw_input
except NameError:
    pass

road_len, race_len, n = map(int, input().split(' '))
segments = [tuple(map(int, input().split(' '))) for i in range(n)]

upper = [s for s in segments if s[0] < s[1]]
lower = [s for s in segments if s[0] > s[1]]

upper.sort()
lower.sort()

for i in range(len(upper) - 1):
    if upper[i][1] > upper[i+1][0]:
        print("Segments %s and %s overlap" % (str(upper[i]), str(upper[i+1])))
        sys.exit(1)

for i in range(len(lower) - 1):
    if lower[i][0] > lower[i+1][1]:
        print("Segments %s and %s overlap" % (str(lower[i]), str(lower[i+1])))
        sys.exit(1)

sys.exit(42)
