#!/bin/bash
USE_SCORING=0
. ../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution trapezoid_integration.cpp

compile gen_random.py

MAXN=10

sample_manual 1
sample_manual 2

tc small-01 gen_random n=1
tc small-02 gen_random n=2
tc small-03 gen_random n=3
tc small-04 gen_random n=4
tc small-05 gen_random n=5
tc small-06 gen_random n=6
tc small-07 gen_random n=7
tc small-08 gen_random n=8
tc small-09 gen_random n=9
tc small-10 gen_random n=10
tc small-11 gen_random n=10 max_x=3
tc small-12 gen_random n=10 max_x=6
tc small-13 gen_random n=10 max_r=1
tc small-14 gen_random n=10 max_r=2

tc_manual ../manual_tests/far_apart.in
tc_manual ../manual_tests/big_area.in
tc_manual ../manual_tests/coincide.in
